#pragma once
#include <utils.h>
#include "Vector3d.h"

enum EntityRenderedType
{
	RENDERED_NONE,
	RENDERED_CUBE
};

enum Direction
{
	NORTH,SOUTH,EAST,WEST
};

typedef struct __CONNECTIONS
{
	unsigned north	: 1; //u =  1
	unsigned east	: 1; //v = -1
	unsigned south	: 1; //u =  1
	unsigned west	: 1; //v = -1
} ConnectionStruct;

class Entity3d
{
public:

	int id;
	union
	{
		ConnectionStruct Connections;
		unsigned char ConnectionsValue;
	} Connectivity;

	EntityRenderedType rendered_type;
	float xpos, ypos;
	float width, length, height;
	void Initialize(float w, float l, float h);

	bool ConstrainToIndoors(Vector3d &originalPoint, const Vector3d &delta, ConnectionStruct extConnections, ConnectionStruct adjacentTunnels);

	void Render(ConnectionStruct externalConnections, ConnectionStruct adjacentTunnels, int targetTexture);

	Entity3d(void);
	~Entity3d(void);
protected:
	void DrawFace(float yangle, float zangle = 0);
	void DrawTopAndBottom(int targetTexture);
	void DrawSideFace(Direction dir, int targetTexture);

	static int __lastid;
};