#pragma once
#include "Entity3dCollection.h"
#include "Generator.h"
#include "Serializable.h"
#include "WindowMapping.h"

class GeneratedEntities
{
public:
	GeneratedEntities(Generator *generator);
	~GeneratedEntities(void);

	void Render();
	void Update(bool force = false);

	bool ConstrainToIndoors(Vector3d &originalPoint, const Vector3d &delta);

	int GetId();
	Generator* GetGenerator();
	bool FillCollection(bool force);

	//measured in cells
	int m_WindowSizeX, m_WindowSizeY;

	bool SetWindowSize(int newWindowSize);

private:

	void Remove();
	bool SetSpaceWindow();
	void PerformTests(WindowMapping &mapping);
	void InitializeTextures();

	Generator *m_Generator;
	Entity3dCollection m_EntityCollection;

	GLuint m_entityTextures	[TEXTURE_COUNT];
	GLuint m_firstEntityList;

	WindowMapping m_spaceWindow;
};
